import Button from '@opentinyvue/vue-button';
import Input from '@opentinyvue/vue-input';
import { renderless as renderless$3, api as api$3 } from '@opentinyvue/vue-renderless/color-select-panel/vue';
import { defineComponent, setup, props, directive } from '@opentinyvue/vue-common';
import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/color-select-panel/hue-select/vue';
import { api, renderless } from '@opentinyvue/vue-renderless/color-select-panel/sv-select/vue';
import { renderless as renderless$2, api as api$2 } from '@opentinyvue/vue-renderless/color-select-panel/alpha-select/vue';
import '@opentinyvue/vue-theme/color-select-panel/index.css';
import { Clickoutside } from '@opentinyvue/vue-directive';
import Collapse from '@opentinyvue/vue-collapse';
import CollapseItem from '@opentinyvue/vue-collapse-item';
import Select from '@opentinyvue/vue-select';
import Option from '@opentinyvue/vue-option';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var render$3 = function render$32() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: "wrapper",
    staticClass: "tiny-color-select-panel__inner__color-select",
    style: {
      background: _vm.state.bg
    }
  }, [_c("div", {
    staticClass: "white"
  }), _c("div", {
    staticClass: "black"
  }), _c("div", {
    ref: "cursor",
    staticClass: "cursor",
    style: {
      top: _vm.state.cursorTop + "px",
      left: _vm.state.cursorLeft + "px",
      transform: "translate(-50%, -50%)"
    }
  })]);
};
var staticRenderFns$3 = [];
var __vue2_script$3 = defineComponent({
  emit: ["ready", "svUpdate"],
  props: {
    color: {
      type: Object
    }
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      api,
      renderless,
      context,
      mono: true
    });
  }
});
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$3, staticRenderFns$3, false, __vue2_injectStyles$3);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var SvSelect = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-color-select-panel__inner"
  }, [_c("sv-select", {
    attrs: {
      "color": _vm.color
    },
    on: {
      "ready": _vm.onSvReady
    }
  }), _c("div", {
    ref: "bar",
    staticClass: "tiny-color-select-panel__inner__hue-select"
  }, [_c("div", {
    ref: "thumb",
    style: {
      top: _vm.state.thumbTop + "px",
      transform: "translateY(-50%)"
    }
  })])], 1);
};
var staticRenderFns$2 = [];
var __vue2_script$2 = defineComponent({
  emits: ["hueUpdate", "svReady", "hueReady"],
  props: {
    color: {
      type: Object
    },
    alpha: {
      type: Boolean
    }
  },
  components: {
    SvSelect
  },
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1,
      mono: true
    });
  }
});
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var HueSelect = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: "alphaWrapper",
    staticClass: "tiny-color-select-panel__alpha",
    on: {
      "click": _vm.onClick
    }
  }, [_c("div", {
    ref: "slider",
    staticClass: "tiny-color-select-panel__alpha__slider",
    style: {
      background: _vm.state.background
    }
  }), _c("div", {
    ref: "alphaThumb",
    staticClass: "tiny-color-select-panel__alpha__thumb",
    style: {
      top: 0,
      left: _vm.state.left + "px",
      transform: "translateX(-50%)"
    }
  })]);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = defineComponent({
  emits: ["ready"],
  props: {
    color: {
      type: Object
    }
  },
  setup: function setup3(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$2,
      api: api$2,
      mono: true
    });
  }
});
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var AlphaSelect = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.state.showPicker ? _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.onClickOutside,
      expression: "onClickOutside"
    }],
    staticClass: "tiny-color-select-panel",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
      }
    }
  }, [_c("hue-select", {
    attrs: {
      "color": _vm.state.color
    },
    on: {
      "hue-ready": _vm.onHueReady,
      "sv-ready": _vm.onSvReady
    }
  }), _vm.alpha ? _c("alpha-select", {
    attrs: {
      "color": _vm.state.color
    },
    on: {
      "ready": _vm.onAlphaReady
    }
  }) : _vm._e(), _c("div", {
    staticClass: "tiny-color-select-panel__tools"
  }, [_vm.state.formats.length ? _c("div", {
    staticClass: "tiny-color-select-panel__tools__format-select"
  }, [_c("tiny-select", {
    model: {
      value: _vm.state.currentFormat,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "currentFormat", $$v);
      },
      expression: "state.currentFormat"
    }
  }, _vm._l(_vm.state.formats, function(formatValue) {
    return _c("tiny-option", {
      key: formatValue,
      attrs: {
        "value": formatValue,
        "label": formatValue
      }
    });
  }), 1)], 1) : _vm._e(), _c("tiny-input", {
    attrs: {
      "size": "small"
    },
    model: {
      value: _vm.state.input,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "input", $$v);
      },
      expression: "state.input"
    }
  }), _c("div", {
    staticClass: "tiny-color-select-panel__tools-btns"
  }, [_c("tiny-button", {
    attrs: {
      "size": "small"
    },
    on: {
      "click": _vm.onCancel
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.colorSelectPanel.cancel")) + " ")]), _c("tiny-button", {
    attrs: {
      "type": "primary",
      "size": "small"
    },
    on: {
      "click": _vm.onConfirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.colorSelectPanel.confirm")) + " ")])], 1)], 1), _c("tiny-collapse", [_vm.state.enableHistory ? _c("tiny-collapse-item", {
    attrs: {
      "title": _vm.t("ui.colorSelectPanel.history"),
      "name": "history"
    }
  }, [_vm.state.stack.length ? _c("div", {
    staticClass: "tiny-color-select-panel__history"
  }, _vm._l(_vm.state.stack, function(color, key) {
    return _c("div", {
      key,
      staticClass: "tiny-color-select-panel__history__color-block",
      style: {
        background: color
      },
      on: {
        "click": function click() {
          return _vm.onHistoryClick(color);
        }
      }
    });
  }), 0) : _vm._e(), !_vm.state.stack.length ? _c("div", [_vm._v(_vm._s(_vm.t("ui.colorSelectPanel.empty")))]) : _vm._e()]) : _vm._e(), _vm.state.enablePredefineColor ? _c("tiny-collapse-item", {
    attrs: {
      "title": _vm.t("ui.colorSelectPanel.predefine"),
      "name": "predefine"
    }
  }, [_vm.state.predefineStack.length ? _c("div", {
    staticClass: "tiny-color-select-panel__predefine"
  }, _vm._l(_vm.state.predefineStack, function(color, key) {
    return _c("div", {
      key,
      staticClass: "tiny-color-select-panel__predefine__color-block",
      style: {
        background: color
      },
      on: {
        "click": function click() {
          return _vm.onPredefineColorClick(color);
        }
      }
    });
  }), 0) : _vm._e(), !_vm.state.predefineStack.length ? _c("div", [_vm._v(_vm._s(_vm.t("ui.colorSelectPanel.empty")))]) : _vm._e()]) : _vm._e()], 1)], 1) : _vm._e();
};
var staticRenderFns = [];
var __vue2_script = defineComponent({
  emits: ["update:modelValue", "cancel", "confirm", "color-update"],
  props: [].concat(props, ["modelValue", "visible", "alpha", "history", "predefine", "format", "enableHistory", "enablePredefineColor"]),
  components: {
    HueSelect,
    AlphaSelect,
    TinyButton: Button,
    TinyInput: Input,
    TinyCollapse: Collapse,
    TinyCollapseItem: CollapseItem,
    TinySelect: Select,
    TinyOption: Option
  },
  directives: directive({
    Clickoutside
  }),
  setup: function setup4(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$3,
      api: api$3
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
